Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members

# TAO_SHMIOP_Profile Class Reference

This class defines the protocol specific attributes required for locating local ORBs over local IPC mechanism to use the shared memory transport. More...

`#include <SHMIOP_Profile.h>`

Inheritance diagram for TAO_SHMIOP_Profile

[legend]
Collaboration diagram for TAO_SHMIOP_Profile:

[legend]
List of all members.

## Public Methods
virtual char | object_key_delimiter (void) const
| TAO_SHMIOP_Profile (const ACE_MEM_Addr &addr, const TAO_ObjectKey &object_key, const TAO_GIOP_Message_Version &version, TAO_ORB_Core *orb_core)
| Profile constructor, same as above except the object_key has already been marshaled.
| TAO_SHMIOP_Profile (const char *host, CORBA::UShort port, const TAO_ObjectKey &object_key, const ACE_INET_Addr &addr, const TAO_GIOP_Message_Version &version, TAO_ORB_Core *orb_core)
| Profile constructor, this is the most efficient since it doesn't require any address resolution processing.
| TAO_SHMIOP_Profile (TAO_ORB_Core *orb_core)
| Profile constructor, default.
| ~TAO_SHMIOP_Profile (void)
| Destructor is to be called only through <_decr_refcnt>.
virtual void | parse_string (const char *string, CORBA::Environment &ACE_TRY_ENV)
| Initialize this object using the given input string.
char* | to_string (CORBA::Environment &ACE_TRY_ENV)
| Return a string representation for this profile. client must deallocate memory.
int | decode (TAO_InputCDR& cdr)
| Initialize this object using the given CDR octet string.
virtual int | encode (TAO_OutputCDR &stream) const
| Encode this profile in a stream, i.e. marshal it.
virtual int | encode_endpoints (void)
virtual const TAO_ObjectKey& | object_key (void) const
| deprecated. return a reference to the Object Key. More...
TAO_ObjectKey* | _key (void) const
| Return a pointer to the Object Key. The caller owns the memory allocated for the returned key.
virtual TAO_Endpoint* | endpoint (void)
| Return pointer to the head of this profile's endpoints list.
virtual size_t | endpoint_count (void)
| Return how many endpoints this profile contains.
void | add_endpoint (TAO_SHMIOP_Endpoint *endp)
CORBA::Boolean | is_equivalent (const TAO_Profile *other_profile)
CORBA::ULong | hash (CORBA::ULong max, CORBA::Environment &ACE_TRY_ENV)
| Return a hash value for this object.
IOP::TaggedProfile& | create_tagged_profile (void)
| Please refer to Profile.h for the documentation of this method.
## Static Public Methods
const char* | prefix (void)
| Return the char string prefix.
## Static Public Attributes
const char | object_key_delimiter_
| The object key delimiter that SHMIOP uses or expects.
## Private Methods
void | create_profile_body (TAO_OutputCDR &cdr) const
| Create an encapsulation of the struct ProfileBody in <cdr>.
int | decode_endpoints (void)
## Private Attributes
TAO_SHMIOP_Endpoint | endpoint_
size_t | count_
| Number of endpoints in the list headed by <endpoint_>.
TAO_ObjectKey | object_key_
| object_key associated with this profile.
IOP::TaggedProfile | tagged_profile_
| The tagged profile info.

## Detailed Description

This class defines the protocol specific attributes required for locating local ORBs over local IPC mechanism to use the shared memory transport.

This class defines the SHMIOP profile.

## Constructor & Destructor Documentation

TAO_SHMIOP_Profile::TAO_SHMIOP_Profile ( | const ACE_MEM_Addr & addr,
| const TAO_ObjectKey & object_key,
| const TAO_GIOP_Message_Version & version,
| TAO_ORB_Core * orb_core )

| Profile constructor, same as above except the object_key has already been marshaled.

TAO_SHMIOP_Profile::TAO_SHMIOP_Profile ( | const char * host,
| CORBA::UShort port,
| const TAO_ObjectKey & object_key,
| const ACE_INET_Addr & addr,
| const TAO_GIOP_Message_Version & version,
| TAO_ORB_Core * orb_core )

| Profile constructor, this is the most efficient since it doesn't require any address resolution processing.

TAO_SHMIOP_Profile::TAO_SHMIOP_Profile ( | TAO_ORB_Core * orb_core )

| Profile constructor, default.

TAO_SHMIOP_Profile::~TAO_SHMIOP_Profile ( | void )

| Destructor is to be called only through <_decr_refcnt>.

## Member Function Documentation

ACE_INLINE TAO_ObjectKey * TAO_SHMIOP_Profile::_key ( | void ) const

| Return a pointer to the Object Key. The caller owns the memory allocated for the returned key. Reimplemented from TAO_Profile.

void TAO_SHMIOP_Profile::add_endpoint ( | TAO_SHMIOP_Endpoint * endp )

| Add <endp> to this profile's list of endpoints (it is inserted next to the head of the list). This profiles takes ownership of <endp>.

void TAO_SHMIOP_Profile::create_profile_body ( | TAO_OutputCDR & cdr ) const`[private]`

| Create an encapsulation of the struct ProfileBody in <cdr>.

IOP::TaggedProfile & TAO_SHMIOP_Profile::create_tagged_profile ( | void )

| Please refer to Profile.h for the documentation of this method. Reimplemented from TAO_Profile.

int TAO_SHMIOP_Profile::decode ( | TAO_InputCDR & cdr )

| Initialize this object using the given CDR octet string. Reimplemented from TAO_Profile.

int TAO_SHMIOP_Profile::decode_endpoints ( | void )`[private]`

| Helper for <decode>. Decodes endpoints from a tagged component. Decode only if RTCORBA is enabled. Furthermore, we may not find TAO_TAG_ENDPOINTS component, e.g., if we are talking to nonRT version of TAO or some other ORB. This is not an error, and we must proceed. Return 0 on success and -1 on failure.

int TAO_SHMIOP_Profile::encode ( | TAO_OutputCDR & stream ) const`[virtual]`

| Encode this profile in a stream, i.e. marshal it. Reimplemented from TAO_Profile.

int TAO_SHMIOP_Profile::encode_endpoints ( | void )`[virtual]`

| Encodes this profile's endpoints into a tagged component. This is done only if RTCORBA is enabled, since currently this is the only case when we have more than one endpoint per profile. Return 0 on success, -1 on failure. Endpoints are transmitted using TAO-proprietory tagged component. Component tag is TAO_TAG_ENDPOINTS and component data is an encapsulation of a sequence of structs, each representing a single endpoint. Data format is specified in iiop_endpoins.pidl. Multiple a la TAG_ALTERNATE_IIOP_ADDRESS components can be used instead of a single proprietory component to transmit multiple endpoints. This is somewhat slower and less convenient. Also, TAG_ALTERNATE_IIOP_ADDRESS does not provide for transmission of endpoint priorities. Reimplemented from TAO_Profile.

TAO_Endpoint * TAO_SHMIOP_Profile::endpoint ( | void )`[virtual]`

| Return pointer to the head of this profile's endpoints list. Reimplemented from TAO_Profile.

size_t TAO_SHMIOP_Profile::endpoint_count ( | void )`[virtual]`

| Return how many endpoints this profile contains. Reimplemented from TAO_Profile.

CORBA::ULong TAO_SHMIOP_Profile::hash ( | CORBA::ULong max,
| CORBA::Environment & ACE_TRY_ENV )

| Return a hash value for this object. Reimplemented from TAO_Profile.

CORBA::Boolean TAO_SHMIOP_Profile::is_equivalent ( | const TAO_Profile * other_profile )

| Return true if this profile is equivalent to other_profile. Two profiles are equivalent iff their tag, object_key, version and all endpoints are the same. Reimplemented from TAO_Profile.

ACE_INLINE const TAO_ObjectKey & TAO_SHMIOP_Profile::object_key ( | void ) const`[virtual]`

| deprecated. return a reference to the Object Key. @ Reimplemented from TAO_Profile.

virtual char TAO_SHMIOP_Profile::object_key_delimiter ( | void ) const`[virtual]`

| Reimplemented from TAO_Profile.

void TAO_SHMIOP_Profile::parse_string ( | const char * string,
| CORBA::Environment & ACE_TRY_ENV )`[virtual]`

| Initialize this object using the given input string. Reimplemented from TAO_Profile.

const char * TAO_SHMIOP_Profile::prefix ( | void )`[static]`

| Return the char string prefix.

char * TAO_SHMIOP_Profile::to_string ( | CORBA::Environment & ACE_TRY_ENV )

| Return a string representation for this profile. client must deallocate memory. Reimplemented from TAO_Profile.

## Member Data Documentation

size_t TAO_SHMIOP_Profile::count_`[private]`

| Number of endpoints in the list headed by <endpoint_>.

TAO_SHMIOP_Endpoint TAO_SHMIOP_Profile::endpoint_`[private]`

| Head of this profile's list of endpoints. This endpoint is not dynamically allocated because a profile always contains at least one endpoint. Currently, a profile contains more than one endpoint, i.e., list contains more than just the head, only when RTCORBA is enabled. However, in the near future, this will be used in nonRT mode as well, e.g., to support TAG_ALTERNATE_IIOP_ADDRESS-style feature. Addressing info of the default endpoint, i.e., head of the list, is transmitted using standard SHMIOP ProfileBody components. See <encode_endpoints> method documentation above for how the rest of the endpoint list is transmitted.

TAO_ObjectKey TAO_SHMIOP_Profile::object_key_`[private]`

| object_key associated with this profile.

const char TAO_SHMIOP_Profile::object_key_delimiter_`[static]`

| The object key delimiter that SHMIOP uses or expects.

IOP::TaggedProfile TAO_SHMIOP_Profile::tagged_profile_`[private]`

| The tagged profile info.

The documentation for this class was generated from the following files:

- SHMIOP_Profile.h
- SHMIOP_Profile.i